clear all
close all

% Konstrukcni rozmery mechanismu
xA = 0.1;
yA = 0.1;
l2 = 0.6;
l3 = 0.5;
fi20 = 0;
fi30 = 0;

% Nacteni namerenych dat 
load namerena_data_90_90_noise

n_poloh = length(XP);

%%%%%%%%%%%%%%%%%%%%%
% Vlastni kalibrace %
%%%%%%%%%%%%%%%%%%%%%

vyvoj = [];

% j_cykl je index cyklu iteraci pri kalibraci
for j_cykl = 1:50
    
    % vazbove podminky
    df1 = xA + l2.*cos(FI2+fi20) + l3.*cos(FI2+fi20+FI3+fi30) - XP;
    df2 = yA + l2.*sin(FI2+fi20) + l3.*sin(FI2+fi20+FI3+fi30) - YP;
        
    difer = -[df1; df2];
   
    % Prubezne zobrazeni rozdilu
    figure(1) 
    title('Difer');
    scale =1;
    quiver(XP,YP,scale*df1,scale*df2,0)
      figure(3)
  quiver(XP,YP,scale*df1,scale*df2)
    
    drawnow;
    
    % Vektorovy (pro vsechny polohy) vypocet derivaci
    
    % Sestaveni Jacobianu
    Jacobi=[ ??? ];
    
    % Jalibrovatelnost
    kalibrovatelnost = ???

    % Reseni prostrednictvim pseudoinverzni matici
    difpar = ???*difer ;

    % Aktualizace parametru
    xA = xA + difpar(1);
	yA = yA + difpar(2);
	l2 = l2 + difpar(3);
	l3 = l3 + difpar(4);
	fi20 = fi20 + difpar(5);
	fi30 = fi30 + difpar(6);	

    vyvoj = [vyvoj;
             xA, yA, l2, l3, fi20, fi30];

end


% Zobrazeni vyvoje parametru
figure(2);
plot(vyvoj);
title('Vyvoj');
legend('xA','yA','l2','l3','fi20','fi30');
grid on;

% Vypis vysledku
xA
yA
l2
l3
fi20_deg = fi20/pi*180
fi30_deg = fi30/pi*180
